package edu.swarthmore.cs.cs71.lecture.junit;

/**
 * The interface to which Lights Out games must conform.
 */
public interface LightsOutModel {
    /** The size of each board dimension. */
    public static final int BOARD_SIZE = 3;

    /**
     * Selects a space to toggle.  Neighbors are also toggled.
     * @param x The X coordinate of the space.
     * @param y The Y coordinate of the space.
     */
    public void toggleSpace(int x, int y);

    /**
     * Determines number of moves made since game start.
     * @return The number of moves the player made.
     */
    public int getMoveCount();

    /**
     * Determines the state of a space.
     * @param x The X coordinate of the space.
     * @param y The Y coordinate of the space.
     * @return <code>true</code> if the space is dark; <code>false</code> if it is lit.
     */
    public boolean getSpaceState(int x, int y);

    public void addListener(LightsOutModelListener listener);
}
